/* This file is part of GNU epsilon, a functional language implementation

Copyright (C) 2002 Luca Saiu

GNU epsilon is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 2, or (at your
option) any later version.

GNU epsilon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with epsilon; see the file COPYING.  If not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA. */

#ifndef MAP_H_
#define MAP_H_

struct map;

/*
This only works if key and value don't contain pointers!
*/

/*
compare should return:
 -1  if A < B
 0   if A == B
 +1  if A > B 
*/
int int_compare (void *, void *);
int double_compare (void *, void *);
int string_compare (void *, void *);
int pointer_compare (void *, void *);

struct map *create_map (int (*compare) (void *, void *),
			size_t size_of_key, size_t size_of_value);
void destroy_map (struct map *map);

void insert_into_map (struct map *map, void *key, void *value);
void *access_map (struct map *map, void *key);

#endif /* #ifndef MAP_H_ */
